/*
 *  krt_rtread_proc.c,v 1.6 1993/11/09 19:27:27 jch Exp
 */

/* Gated Release 3.5 */
/* Copyright (c) 1990,1991,1992,1993,1994 by Cornell University. All rights */
/* reserved. Refer to Particulars and other Copyright notices at the end of this */
/* file. */


#define	INCLUDE_NLIST
#define	INCLUDE_ROUTE
#define	INCLUDE_KVM
#include "include.h"
#ifdef	PROTO_INET
#include "inet.h"
#endif	/* PROTO_INET */
#ifdef	PROTO_ISO
#include "iso.h"
#endif	/* PROTO_ISO */
#include "krt.h"
#include "krt_var.h"
#include <stdio.h>

typedef struct rtable krt_type;

#define	krt_size	sizeof(krt_type)
#define	krt_conv(ptr)	(&(ptr))

 /*  Read the kernel's routing table.			*/
int
krt_rtread __PF1(tp, task *)
{
    int i, fl, hashsize = 4;
    size_t rtbufsize;
    krt_type *krt, m_buf, **base;
    rt_parms rtparms;
    FILE *DFile;
    struct sockaddr_in *addr;                                 

    bzero((caddr_t) &rtparms, sizeof (rtparms));
    rtparms.rtp_n_gw = 1;

    DFile = fopen("/proc/net/route","r");
    if(DFile == NULL)
	return EBADF;

    trace_only_tp(tp,
		  TRC_NL_BEFORE,
		  ("krt_rtread: Initial routes read from kernel (via /proc/net/route):"));

    /* read route data from /proc   */

    rtbufsize = hashsize * sizeof(krt_type *);
    base = (krt_type **) task_block_malloc(rtbufsize);
    krt = &m_buf;
/* skip over header line */
    i=fscanf(DFile,"%*s\t%*s\t%*s\t%*s\t%*s\t%*s\t%*s\t%*s\t%*s\t%*s\n");

    while(!feof(DFile)){
		i=fscanf(DFile,"%*s\t%08lX\t%08lX\t%02x\t%*d\t%*d\t%*d\t%08lX\t%*d\t%*d\n",     
                  &krt->rt_dst, &krt->rt_gateway, &fl,
                  &krt->rt_mask);
		krt->rt_flags = fl;

/*   Given no data to the contrary, assume that all routes are INET and
     set port and sin_zero.     */
                                                               
                addr = (struct sockaddr_in *) &krt->rt_dst;               
                addr->sin_family = AF_INET;                               
                addr->sin_port = 0;                                       
                bzero((caddr_t) addr->sin_zero, sizeof (addr->sin_zero)); 
                                                               
                addr = (struct sockaddr_in *) &krt->rt_gateway;           
                addr->sin_family = AF_INET;                               
                addr->sin_port = 0;                                       
                bzero((caddr_t) addr->sin_zero, sizeof (addr->sin_zero)); 

		rtparms.rtp_dest = sock2gated((struct sockaddr *)&krt->rt_dst, unix_socksize(&krt->rt_dst));
		rtparms.rtp_dest_mask = (sockaddr_un *) 0;
		rtparms.rtp_router = sock2gated((struct sockaddr *)&krt->rt_gateway, unix_socksize(&krt->rt_gateway));
		rtparms.rtp_state = krt_flags_to_state((flag_t) krt->rt_flags);

		krt_rtread_add(tp,
			       &rtparms,
			       (flag_t) krt->rt_flags,
			       FALSE,
			       "REMNANT");
    }
    task_block_reclaim(rtbufsize, (caddr_t) base);

    return 0;
}
