/*
 *  krt_symbols_proc.c,v 1.3 1993/10/27 01:41:36 jch Exp
 */

/* Gated Release 3.5 */
/* Copyright (c) 1990,1991,1992,1993,1994 by Cornell University. All rights */
/* reserved. Refer to Particulars and other Copyright notices at the end of this */
/* file. */


#define	INCLUDE_FILE
#define	INCLUDE_IOCTL
#include "include.h"
#ifdef	PROTO_INET
#include "inet.h"
#endif	/* PROTO_INET */
#include "krt.h"
#include "krt_var.h"
#include <stdio.h>


int
krt_symbols __PF1(tp, task *)
{
    char *resp;
    char buf[240], *bp = buf;
    FILE *DF;

#ifdef	PROTO_INET
    resp = (char *) DF = fopen("/proc/net/snmp","r");
    if ( DF != NULL) {
      resp = fgets(bp,240,DF);      /* skip header */
      resp = fgets(bp,6,DF);
      resp += 4;                    /* point at IP Forwarding value */
      fclose (DF);
    }
    if (resp) {
	inet_ipforwarding = atoi(resp) > 0;
	trace_tp(tp,
		 TR_KRT_SYMBOLS,
		 0,
		 ("krt_symbols: IP forwarding: %u using %u\n",
		  atoi(resp),
		  inet_ipforwarding));
    }
    resp = bp;
    strcpy(bp,"1");              /* UDP Checksums always on for Linux */
    if (resp) {
	inet_udpcksum = atoi(resp) != 0;
	trace_tp(tp,
		 TR_KRT_SYMBOLS,
		 0,
		 ("krt_symbols: UDP checksums: %u using %u\n",
		  atoi(resp),
		  inet_udpcksum));
    }
#endif	/* PROTO_INET */

    DF = fopen("/proc/version","r");                   
    if ( DF != NULL) {                                                  
        krt_version_kernel = fgets(bp,80,DF);
        fclose (DF);                                                      
    }                                                                   

    trace_tp(tp,
	     TR_KRT_SYMBOLS,
	     0,
	     ("krt_symbols: krt_version_kernel = %s",
	      krt_version_kernel));
    return 0;
}
